const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_memberships = sequelize.define(
    'user_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"ACTIVE",


"CANCELLED",


"EXPIRED"

        ],

      },

started_at: {
        type: DataTypes.DATE,
      
      

      },

next_billing_at: {
        type: DataTypes.DATE,
      
      

      },

cancelled_at: {
        type: DataTypes.DATE,
      
      

      },

ends_at: {
        type: DataTypes.DATE,
      
      

      },

price_supercharged: {
        type: DataTypes.INTEGER,
      
      

      },

perks_snapshot: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.user_memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.user_memberships.belongsTo(db.membership_plans, {
      as: 'membership_plan',
      foreignKey: {
        name: 'membership_planId',
      },
      constraints: false,
    });




    db.user_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_memberships;
};


